﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.IO.MemoryMappedFiles;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using SeAH_Pipe_Tab_Cutter_Lib;

namespace SeAH_PIpe_Tab_Cutter_App
{
    public partial class SeAH_Pipe_TabApp : Form
    {
        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi)]
        public unsafe struct STRUCT_1
        {
            void Init()
            {
                this.Count = 0;
            }
            [FieldOffset(0)]
            public int Count;
            [FieldOffset(1024)]
            public fixed byte value[1024];
        }

        MemoryMappedFile mapFile = MemoryMappedFile.OpenExisting(
                        "SeAH_Pipe_Tab_SharedMemory",
                        MemoryMappedFileRights.ReadWrite);

        SeAH_Pipe_TabLib _SeAH_TabCutterLib = new SeAH_Pipe_TabLib();

        public SeAH_Pipe_TabApp()
        {
            InitializeComponent();
            //mapFile.CreateViewStream()
        }

        private void BT_Init_Click(object sender, EventArgs e)
        {
           MemoryMappedFileSecurity CustomSecurity = new MemoryMappedFileSecurity();
           CustomSecurity.AddAccessRule(new System.Security.AccessControl.AccessRule<MemoryMappedFileRights>("everyone", MemoryMappedFileRights.FullControl, System.Security.AccessControl.AccessControlType.Allow));

            //access memory mapped file (need persistence)
            using (var memMapFile = MemoryMappedFile.CreateOrOpen("SeAH_Pipe_Tab_SharedMemory", 1024, MemoryMappedFileAccess.ReadWriteExecute, MemoryMappedFileOptions.None, CustomSecurity, System.IO.HandleInheritability.Inheritable))
            {
                using (var accessor = memMapFile.CreateViewAccessor())
                {
                    STRUCT_1 data;

                    accessor.Read<STRUCT_1>(0, out data);

                    Console.WriteLine(data.Count);
                    //Console.WriteLine(data.Number);
                }
            }
            _SeAH_TabCutterLib.SeAH_Init();
        }
    }
}
